* ------------------------------------------------------------- ImpC2SMC
      Program ImpC2SMC

* Reformats Imperial College accelerogram file into smc

* Barebones program:

* Dates: 02/27/01 - Written by D. Boore
*        03/07/01 - Modified to deal with corrected data

      character f_in*80, f_smc*80, stem_c*80

      character char_head(11)*80, comments(400)*80,
     : date_c*8, time_c*11

      integer int_head(48)
      real real_head(50)

      real y(:)
      allocatable :: y

      iflag = 0
      call datetime(date_c, time_c, iflag)

      write(*,'(a)') ' Enter f_in: '
      f_in = ' '
      read(*,'(a)') f_in
      call trim_c(f_in,nc_f_in)

      write(*,'(a)') ' Type of acceleration (1=uncorr, 2=corr): '
      read(*,*) i_type_accel

      if (i_type_accel .eq. 1) then
        nskip = 25
        n_ts = 1
        f_smc = ' '
        write(*,'(a)') ' Enter f_smc: '
        read(*,'(a)') f_smc
        call trim_c(f_smc,nc_f_smc)
      else
        nskip = 29
        n_ts = 3
        stem_c = ' '
        write(*,'(a)') ' Enter smc stem: '
        read(*,'(a)') stem_c
        call trim_c(stem_c,nc_stem_c)
      endif

      write(*,'(a)') ' Enter sps, npts: '
      read(*,*) sps, npts

      call get_lun(nu_in)

      open(unit=nu_in,file=f_in,status='unknown')


      call skip(nu_in, nskip)

      do i_ts = 1, n_ts
  
        allocate (y(npts))

        call skip(nu_in,1)
        read(nu_in,'(6(1x,e12.5))') (y(i),i = 1, npts)

        do i = 1, 11
          char_head(i) = '*'
        end do

        inull = -32768
        do i = 1, 48
          int_head(i) = inull
        end do
        int_head(17) = npts

        rnull = 1.7e38
        do i = 1, 50
          real_head(i) = rnull
        end do
        real_head(2) = sps

        ncomments = 1
        comments(ncomments) = '|'
        ncomments = ncomments + 1
        comments(ncomments) = 
     :     '|  Reformatted input file: '//f_in(1:nc_f_in)
        ncomments = ncomments + 1
        comments(ncomments) = '|  on '//date_c//' at time '//time_c
        ncomments = ncomments + 1
        comments(ncomments) = '|'
        int_head(16) = ncomments 

        if (i_type_accel .eq. 1) then
           i_type = 2
        else
           i_type = i_ts + 1
           f_smc = ' '
           if (i_ts .eq. 1) f_smc = stem_c(1:nc_stem_c)//'.acc'
           if (i_ts .eq. 2) f_smc = stem_c(1:nc_stem_c)//'.vel'
           if (i_ts .eq. 3) f_smc = stem_c(1:nc_stem_c)//'.dis'
        end if

        call SMCWrite(f_smc, y, char_head, i_type, 
     :                    int_head, real_head, comments)

        deallocate (y)

      end do

      stop
      end
* ------------------------------------------------------------- ImpC2SMC

      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\datetime.for'
      include '\forprogs\smcwrite.for'


      