      Program ESTB_Acc2SMC

* Reformat into a smc file an ascii file in which there are possible comments 
* preceded by "!" or "|", followed by one header line, followed by the data
* in two columns: time, data

* Sample control file:
* first line below starts the control, with line 1, col 1 = "N" in "Nominal":
*!Control file for ESTB_Acc2SMC      ! first line
*! Revision of program involving a change in the control file on this date:
*   02/02/12
*!Name of summary file:
* estb_acc2smc.sum
*!Input file name (time,data pairs; "stop" in any column to quit):
*A11-Re2HNE.ACC
*A11-Re2HNN.ACC
*A11-Re2HNZ.ACC
*A16-Re9HNE.ACC
*A16-Re9HNN.ACC
*A16-Re9HNZ.ACC
*A21-Re13HNE.ACC
*A21-Re13HNN.ACC
*A21-Re13HNZ.ACC
*STOP

* Dates: 02/02/12 - Written by D. Boore, patterned after estb_tra2smc
 
      real time(200000), ts(200000), dum(15)
      character f_ctl*120, f_sum*120, f_asc*120, f_smc*120, f_asc_4*4
      character char_head(11)*80, comments(100)*80, hdr_cmmnts(100)*79
      character precision*20, cmnts2skip(50)*80
      character extension_c*30, read_format_c*10, format_c*80
      character date_ctl_correct*8, date_ctl_in*30
      character buf*300
      integer int_head(48), ios
      real real_head(50)

      logical f_exist

      do i = 2, 11
        char_head(i) = '*'
      end do

      ndimen_max = 200000
      
      int_null = -32768
      do i = 1, 48
        int_head(i) = int_null
      end do
*      int_head(13) = 0
*      int_head(14) = 0

      real_null = 1.7e+38
      do i = 1, 50
        real_head(i) = real_null
      end do

      f_exist = .false.
      do while (.not. f_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = estb_acc2smc.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) .eq. '    ') f_ctl = 'estb_acc2smc.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_exist)
        if (.not. f_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do
      call get_lun(nu_ctl)
      open(unit=nu_ctl, file=f_ctl(1:nc_f_ctl), status='unknown')

      call skipcmnt(nu_ctl, cmnts2skip,nc_cmnts2skip)
      date_ctl_in = ' '
      read(nu_ctl,'(a)') date_ctl_in
      call trim_c(date_ctl_in,nc_date_ctl_in)
      
      date_ctl_correct = ' '
      date_ctl_correct = '02/02/12'
      call trim_c(date_ctl_correct,nc_date_ctl_correct)

      if (date_ctl_correct(1:nc_date_ctl_correct) .ne. 
     :    date_ctl_in(1:nc_date_ctl_in)) then
        write(*,'(a)') 
     :     ' The control file has the wrong date; update your '//
     :       'control file and rerun the program!'
        close(nu_ctl)
        stop
      end if
      
      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)
      f_sum = ' '
      read(nu_ctl,'(a)') f_sum
      call trim_c(f_sum, nc_f_sum)
      call get_lun(nu_sum)
      open(unit=nu_sum, file=f_sum(1:nc_f_sum), status='unknown')
      write(nu_sum,'(a)') '  Summary program for program ASC2SMC'      

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)

      loop over files: DO

        f_asc = ' '
        read(nu_ctl,'(a)',iostat=ios) f_asc
        IF (ios /= 0) THEN
          EXIT loop over files
        END IF
        call trim_c(f_asc,nc_f_asc)
        f_asc_4 = ' '
        f_asc_4 = f_asc(1:4)
        call upstr(f_asc_4)
        if(f_asc_4 == 'STOP') EXIT loop over files
      
        f_exist = .false.
        inquire(file=f_asc(1:nc_f_asc), exist=f_exist)
        if (.not. f_exist) then
          write(*,'(a)') ' ******* FILE '//f_asc(1:nc_f_asc)//
     :        ' DOES NOT EXIST *******, going to next file' 
          write(nu_sum,'(a)') ' ******* FILE '//f_asc(1:nc_f_asc)//
     :        ' DOES NOT EXIST *******, going to next file' 
          CYCLE loop over files
        end if


        write(nu_sum,'(2a)') '  Processing file: ', f_asc(1:nc_f_asc)

        print *,' '
        print *,' Processing file: '//f_asc(1:nc_f_asc)

        call get_lun(nu_asc)
        open(unit=nu_asc, file=f_asc(1:nc_f_asc), status='unknown')
      
        write(nu_sum,'(1x,a,1x,i4)') ' nu_asc = ', nu_asc

        iflag_found_sample_rate = 0
        ihead = 0
        hdr_cmmnts = ' '
        find sample rate: DO
        
          ihead = ihead + 1
          
          buf = ' '
          read(nu_asc,'(a)') buf
          call trim_c(buf, nc_buf)
          hdr_cmmnts(ihead) = buf(1:nc_buf)
        
          if (buf(1:14) == 'Sampling rate:') then
            read(buf(15:nc_buf),*) sps
            iflag_found_sample_rate = 1
            print *,' ihead, sps = ', ihead, sps
            EXIT find sample rate
          end if
          
        END DO find sample rate
        
        if (iflag_found_sample_rate == 0) then
          print *, ' ERROR, sps not found; Cycle to next file!!'
          CYCLE loop over files
        end if
        
        find end of headers: DO

          ihead = ihead + 1        
          buf = ' '
          read(nu_asc,'(a)') buf
          call trim_c(buf, nc_buf)
          hdr_cmmnts(ihead) = buf(1:nc_buf)
          if (buf(1:8) == '(CM/s^2)') then
            print *,' found end of headers at ihead = ', ihead
            EXIT find end of headers
          end if
          
        END DO find end of headers
        
        n_hdr_cmmnts = ihead          
        
! Now read data:   (15th entry)

        n_ts = 0
        
        loop over points: DO
          
          read(nu_asc,*, iostat=ios) (dum(i), i=1, 2)
          if (ios /= 0) then  ! reached end of time series
            close(nu_asc)
            EXIT loop over points
          end if
          
          n_ts = n_ts + 1
          ts(n_ts) = dum(2)
          time(n_ts) = real(n_ts - 1)/sps
          
        END DO loop over points
          
            


        
      write(nu_sum,'(a,1x,i6,1x,f7.2)') '    n_ts, sps = ', n_ts, sps

      int_head(17) = n_ts
      
      real_head(2) = sps
      
      ncomments = 0
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      do i = 1, n_hdr_cmmnts
        ncomments = ncomments + 1
        comments(ncomments) = '|'//hdr_cmmnts(i)
      end do
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      ncomments = ncomments + 1
      comments(ncomments) = '| File '//f_asc(1:nc_f_asc)//
     : ' reformatted by program ESTB_Tra2SMC'
      ncomments = ncomments + 1
      comments(ncomments) = '|'

      int_head(16) = ncomments

      f_smc = ' '
      
      f_smc = f_asc(1:nc_f_asc)//'.smc8'
      
      call trim_c(f_smc, nc_f_smc)

      write(*,'(a)') ' Writing file '//f_smc(1:nc_f_smc)
      write(nu_sum,'(a)') ' Writing file '//f_smc(1:nc_f_smc)

      precision = 'HIGH'
      call smcwrite(f_smc, precision,
     :              ts, char_head, 0, 
     :              int_head, real_head, comments)
     
      END DO loop over files

      close(nu_ctl)
      close(nu_sum)

      stop
      end

      include '\forprogs\skip.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\distaz.for'
